"use server"

import { getSignedImageUrl } from "@/lib/s3";

// const OpenAIImageSchema = z.object({
//   description: z.string(),
//   alt: z.string(),
// })

export async function generateImageText(fileKey: string) {
  const imageUrl = await getSignedImageUrl(`original/${fileKey}.webp`);
  console.log("Generating image text...")

  try {
    const imageRes = await fetch(imageUrl);
    if (!imageRes.ok) throw new Error("Failed to fetch image");

    const arrayBuffer = await imageRes.arrayBuffer();
    const base64 = arrayBufferToBase64(arrayBuffer);

    const resDescription = await fetch("http://10.0.20.11:11434/api/generate", {
      method: "POST",
      headers: { "Content-Type": "application/json" },
      body: JSON.stringify({
        model: "moondream",
        prompt: "Describe this image in detail",
        // format: "json",
        stream: false,
        images: [base64],
      }),
    })

    const resAlt = await fetch("http://10.0.20.11:11434/api/generate", {
      method: "POST",
      headers: { "Content-Type": "application/json" },
      body: JSON.stringify({
        model: "moondream",
        prompt: "Write a short alt text describing this image.",
        // format: "json",
        stream: false,
        images: [base64],
      }),
    })

    const descJson = await resDescription.json();
    const altJson = await resAlt.json();
    console.log("Response:", descJson.response)
    console.log("Response:", altJson.response)

    // const json = await res.json();
    // const responseText = json.response?.trim();

    // const data = await res.json();
    // const text = data.res?.trim();

    // // const text = await res.text()
    // console.log("Response:", data)
    // console.log("Response:", text)
    // const parsed = JSON.parse(text)
    // return parsed.response || "(no response)"
    return {
      description: descJson.response,
      alt: altJson.response,
    }
  } catch (err) {
    console.error("error:", err)
    return null
  }
}

function arrayBufferToBase64(buffer: ArrayBuffer): string {
  let binary = "";
  const bytes = new Uint8Array(buffer);
  const len = bytes.byteLength;
  for (let i = 0; i < len; i++) {
    binary += String.fromCharCode(bytes[i]);
  }
  return btoa(binary);
}
