import prisma from "@/lib/prisma"

async function updateSortIndices() {
  const galleries = await prisma.gallery.findMany({ orderBy: { createdAt: "asc" } })
  const albums = await prisma.album.findMany({ orderBy: { createdAt: "asc" } })

  for (let i = 0; i < galleries.length; i++) {
    await prisma.gallery.update({
      where: { id: galleries[i].id },
      data: { sortIndex: i },
    })
  }

  for (let i = 0; i < albums.length; i++) {
    await prisma.album.update({
      where: { id: albums[i].id },
      data: { sortIndex: i },
    })
  }

  console.log("✅ sortIndex updated for all galleries and albums")
}

updateSortIndices().catch((e) => {
  console.error(e)
  process.exit(1)
})
